var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { Suspense, useEffect } from 'react';
import './KamandApp.css';
import Scaffold from './pages/Scaffold';
import { create } from 'jss';
import rtl from 'jss-rtl';
import { StylesProvider, createGenerateClassName, jssPreset } from '@material-ui/styles';
import { MuiThemeProvider, createMuiTheme } from '@material-ui/core/styles';
import Notifier from './Notifier';
import './translations/i18n';
import { DefaultLoadingIndicator } from './components/LazyLoadOnView';
var KamandApp = function (props) {
    var theme = createMuiTheme({
        direction: props.direction || 'rtl',
        typography: {
            // Use the system font instead of the default Roboto font.
            fontFamily: [
                'Nahid',
            ].join(','),
        },
        palette: {
            selected: {
                row: '#bbd2f6',
            }
        },
    });
    // @ts-ignore
    var jss = (props.direction || 'rtl') === 'rtl' ? { jss: create({ plugins: __spreadArray(__spreadArray([], jssPreset().plugins, true), [rtl()], false) }) } : undefined;
    var generateClassName = createGenerateClassName();
    useEffect(function () {
        if (document && document.getElementsByTagName && props.direction === 'rtl') {
            var htmlElement = document.getElementsByTagName("HTML")[0];
            htmlElement.setAttribute("dir", props.direction);
        }
    }, [props.direction]);
    return (React.createElement(StylesProvider, __assign({}, jss, { generateClassName: generateClassName }),
        React.createElement(MuiThemeProvider, { theme: theme },
            React.createElement(Notifier, null),
            React.createElement(Suspense, { fallback: React.createElement(DefaultLoadingIndicator, null) },
                React.createElement(Scaffold, { menus: props.menus, login: props.login, home: props.home }, props.children)))));
};
export default KamandApp;
