var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from "react";
import { Grid, Grow } from "@material-ui/core";
import IconButton from "@material-ui/core/IconButton";
import ScannerIcon from "@material-ui/icons/CameraAlt";
import QrReader from "react-qr-reader";
import { TextKamandField } from "./Fields";
export var QRCodeReaderField = function (_a) {
    var value = _a.value, name = _a.name, label = _a.label, onChange = _a.onChange, props = __rest(_a, ["value", "name", "label", "onChange"]);
    var _b = React.useState(false), open = _b[0], setOpen = _b[1];
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var handleOpen = function () {
        setOpen(!open);
    };
    var handleScan = function (data) {
        if (data) {
            // console.log(data);
            onChange({ target: { name: name !== null && name !== void 0 ? name : '', value: data } });
            // setScanValue(data)
        }
    };
    var handleError = function (err) {
        console.log(err);
    };
    return (
    // <div >
    React.createElement(Grid, { container: true, spacing: 3 },
        React.createElement(Grid, { item: true, xs: 6 },
            React.createElement(TextKamandField, __assign({ value: value, label: label, name: name, onChange: onChange }, props))),
        React.createElement(Grid, { item: true, xs: 3 },
            React.createElement(IconButton, { onClick: handleOpen },
                React.createElement(ScannerIcon, { color: 'primary' }))),
        React.createElement(Grow, { in: open, mountOnEnter: true, timeout: 500 },
            React.createElement("div", { style: {
                    position: 'absolute',
                    top: 50,
                    left: 80,
                    display: 'flex',
                    flexDirection: 'column',
                    alignItems: 'center',
                    justifyContent: 'space-between',
                    padding: 60 + "px",
                    marginLeft: 1,
                    width: '50%',
                    height: '50%',
                    // transition: 'background-color 0.5s ease',
                    backgroundColor: 'rgba(255, 255, 255, .9)'
                }, onClick: handleOpen },
                React.createElement(QrReader, { delay: 300, onError: handleError, onScan: handleScan, style: { width: '80%' } })))));
};
